#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <dolphot.h>
#include "acsfilters.h"
#include "acsdistort.h"

int main(int argc,char**argv) {
   char*ptr,*ptr2,str[8001];
   int cm,filt;
   double x,y;

   if (argc!=1) {
      printf("Usage: %s\n",*argv);
      printf("Data given via stdin, in column format:\n");
      printf("  camera filter X Y <data>\n");
      printf("  camera: 0=HRC, 1=WFC1, 2=WFC2\n");
      printf("  filter: F555W, etc\n");
      return -1;
   }
   initfilters();
   while (fgets(str,8001,stdin)) {
      cm=strtol(str,&ptr,10);
      if (ptr==str) {
	 printf("No camera found:\n%s",str);
	 return -1;
      }
      if (cm<0 || cm>2) {
	 printf("Illegal camera (0, 1, 2 OK):\n%s",str);
	 return -1;
      }
      while (*ptr==' ') ptr++;
      for (ptr2=ptr;*ptr2 && *ptr2!=' ';ptr2++);
      if (!*ptr2) {
	 printf("No filter found:\n%s",str);
	 return -1;
      }
      *ptr2=0;
      filt=findfilt(ptr);
      *ptr2=' ';
      ptr=ptr2;
      x=strtod(ptr,&ptr2);
      if (ptr2==ptr) {
	 printf("No X value found:\n%s",str);
	 return -1;
      }
      if (x<0 || (cm==0 && x>1024) || (cm>0 && x>4096)) {
	 printf("Illegal X value (0-1024 HRC, 0-4096 WFC):\n%s",str);
	 return -1;
      }
      ptr=ptr2;
      y=strtod(ptr,&ptr2);
      if (ptr2==ptr) {
	 printf("No Y value found:\n%s",str);
	 return -1;
      }
      if (y<0 || (cm==0 && y>1024) || (cm>0 && y>2048)) {
	 printf("Illegal Y value (0-1024 HRC, 0-2048 WFC):\n%s",str);
	 return -1;
      }
      ACSfwddistort(cm,filt,&x,&y);
      if (cm==0) {
	 x=-x*filters[filt].idc[0][cm][4]+filters[filt].idc[0][cm][2];
	 y=y*filters[filt].idc[0][cm][4]+filters[filt].idc[0][cm][3];
      }
      else {
	 x=x*filters[filt].idc[0][cm][4]+filters[filt].idc[0][cm][2];
	 y=-y*filters[filt].idc[0][cm][4]+filters[filt].idc[0][cm][3];
      }
      printf("%8.3f %8.3f\n",x,y);
   }
   return 0;
}
